<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/Accessory.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('Accessory_8cpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Accessory.cpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*************************************************************</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">project: &lt;Accessories&gt;</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">author: &lt;Thierry PARIS&gt;</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">description: &lt;Class for a generic accessory&gt;</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">*************************************************************/</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Accessories_8h.html">Accessories.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;ActionsStack.hpp&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;EEPROM.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<a class="code" href="classAccessory.html">Accessory</a> *Accessory::pFirstAccessory = NULL;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno"><a class="line" href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">   15</a></span>&#160;<a class="code" href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">Accessory::Accessory</a>()</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a> = NULL;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    this-&gt;movingPositionsSize = 0;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    this-&gt;movingPositionsAddCounter = 0;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    this-&gt;pMovingPositions = NULL;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    this-&gt;lastMovingPosition = 255;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">SetLastMoveTime</a>();</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    this-&gt;duration = 0;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    this-&gt;startingMillis = 0;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    Accessory::Add(<span class="keyword">this</span>);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">   29</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">Accessory::AdjustMovingPositionsSize</a>(uint8_t inNewSize)</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordflow">if</span> (inNewSize &lt;= this-&gt;movingPositionsSize)</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <a class="code" href="structMovingPosition.html">MovingPosition</a> *pNewList = <span class="keyword">new</span> <a class="code" href="structMovingPosition.html">MovingPosition</a>[inNewSize];</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">int</span> i = 0;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordflow">for</span> (; i &lt; this-&gt;movingPositionsSize; i++)</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        pNewList[i] = this-&gt;pMovingPositions[i];</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordflow">for</span> (; i &lt; inNewSize; i++)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        pNewList[i].Id = UNDEFINED_ID;  <span class="comment">//empty</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    this-&gt;movingPositionsSize = inNewSize;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordflow">if</span> (this-&gt;pMovingPositions != NULL)</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">delete</span>[] this-&gt;pMovingPositions;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    this-&gt;pMovingPositions = pNewList;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;}</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment">// Returns the index of the new added position.</span></div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">   49</a></span>&#160;uint8_t <a class="code" href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">Accessory::AddMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPosition)</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <a class="code" href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">Accessory::AdjustMovingPositionsSize</a>(this-&gt;movingPositionsAddCounter + 1);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    this-&gt;pMovingPositions[this-&gt;movingPositionsAddCounter].<a class="code" href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">Id</a> = inId;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    this-&gt;pMovingPositions[this-&gt;movingPositionsAddCounter++].<a class="code" href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">Position</a> = inPosition;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordflow">return</span> this-&gt;movingPositionsAddCounter - 1;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">   59</a></span>&#160;uint8_t <a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">Accessory::IndexOfMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)<span class="keyword"> const</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;movingPositionsSize; i++)</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">if</span> (this-&gt;pMovingPositions[i].Id == inId)</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="keywordflow">return</span> i;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">return</span> 255;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;}</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">   68</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">Accessory::GetMovingPosition</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)<span class="keyword"> const</span></div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;movingPositionsSize; i++)</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keywordflow">if</span> (this-&gt;pMovingPositions[i].Id == inId)</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;            <span class="keywordflow">return</span> this-&gt;pMovingPositions[i].<a class="code" href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">Position</a>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordflow">return</span> UNDEFINED_POS;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;}</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">   77</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a>()</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;{</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordflow">if</span> (this-&gt;duration &gt; 0)</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        this-&gt;startingMillis = millis();</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Accessory start action &quot;</span>));</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    Serial.println(this-&gt;startingMillis);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;}</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classAccessory.html#a9a3c9f8604297fcb55141a720169fd90">   90</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a>(ACC_STATE inState)</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;{</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">if</span> (this-&gt;duration &gt; 0)</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        this-&gt;startingMillis = millis();</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">SetState</a>(inState);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Accessory start action at &quot;</span>));</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    Serial.print(this-&gt;startingMillis);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;ms for state &quot;</span>));</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    Serial.print(inState);</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">if</span> (this-&gt;startingMillis == 0)</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        Serial.println(<span class="stringliteral">&quot; ended&quot;</span>);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        Serial.println(<span class="stringliteral">&quot;&quot;</span>);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;}</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="keywordtype">void</span> Accessory::CheckPort()<span class="keyword"> const</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword"></span>{</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">GetPort</a>() == NULL)</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    {</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;One accessory have no port !&quot;</span>));</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    }</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;}</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a3de65543a892b3418df72f54439605cb">Accessory::ResetAction</a>()</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;{</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;End (reset) action at &quot;</span>));</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    Serial.print(millis() - this-&gt;startingMillis);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;ms for &quot;</span>));</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    Serial.print(this-&gt;duration);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    Serial.println(F(<span class="stringliteral">&quot;ms&quot;</span>));</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    this-&gt;startingMillis = 0;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;}</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">  134</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">Accessory::ActionEnded</a>()</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;{</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keywordflow">if</span> (this-&gt;startingMillis &lt;= 0)</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keywordflow">if</span> ((<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span>)(millis() - this-&gt;startingMillis) &gt; this-&gt;duration)</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_VERBOSE_MODE</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;End action at &quot;</span>));</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        Serial.print(millis() - this-&gt;startingMillis);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;ms for &quot;</span>));</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        Serial.print(this-&gt;duration);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;ms&quot;</span>));</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        this-&gt;startingMillis = 0;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    }</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;}</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno"><a class="line" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">  157</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">Accessory::SetLastMovingPosition</a>(uint8_t inLastPositionIndex)</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;{</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    this-&gt;lastMovingPosition = inLastPositionIndex; </div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    Accessories::EEPROMSave();</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;}</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">  165</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">Accessory::SetStateRaw</a>(ACC_STATE inNewState)</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;{</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordflow">if</span> (this-&gt;state != inNewState)</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        this-&gt;state = inNewState;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        Accessories::EEPROMSave();</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    }</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;}</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="preprocessor">#ifndef NO_EEPROM</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessory.html#a49f289549f486e8307ec06123939ca40">Accessory::EEPROMSave</a>(<span class="keywordtype">int</span> inPos, <span class="keywordtype">bool</span> inSimulate)</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;{</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordflow">if</span> (!inSimulate)</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    {</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        EEPROM.write(inPos, this-&gt;state);</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        EEPROM.write(inPos+1, this-&gt;<a class="code" href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">GetLastMovingPosition</a>());</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        EEPROM.write(inPos+2, this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">GetSpeed</a>());</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    }</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    <span class="keywordflow">return</span> inPos + 3;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;}</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keywordtype">int</span> <a class="code" href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a>(<span class="keywordtype">int</span> inPos)</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;{</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    this-&gt;state = (ACC_STATE)EEPROM.read(inPos++);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a>(EEPROM.read(inPos++));</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    this-&gt;<a class="code" href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">pPort</a>-&gt;<a class="code" href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">SetSpeed</a>(EEPROM.read(inPos++));</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordflow">return</span> inPos;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;}</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_PRINT_ACCESSORIES</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keywordtype">void</span> Accessory::printMovingPositions()</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;{</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; this-&gt;movingPositionsSize; i++)</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    {</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        Serial.print(i);</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        Serial.print(F(<span class="stringliteral">&quot;: id &quot;</span>));</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        Serial.print(this-&gt;pMovingPositions[i].Id);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; / pos &quot;</span>));</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        Serial.println(this-&gt;pMovingPositions[i].Position);</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    }</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;}</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="comment">// Accessory list part</span></div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="keywordtype">void</span> Accessory::Add(<a class="code" href="classAccessory.html">Accessory</a> *inpAccessory)</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;{</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keywordflow">if</span> (Accessory::pFirstAccessory == NULL)</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    {</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        Accessory::pFirstAccessory = inpAccessory;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        inpAccessory-&gt;<a class="code" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">SetNextAccessory</a>(NULL);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    }</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = Accessory::pFirstAccessory;</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="keywordflow">while</span> (pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>() != NULL)</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    pCurr-&gt;<a class="code" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">SetNextAccessory</a>(inpAccessory);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    inpAccessory-&gt;<a class="code" href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">SetNextAccessory</a>(NULL);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;}</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00233"></a><span class="lineno"><a class="line" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">  233</a></span>&#160;uint8_t <a class="code" href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a>()</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;{</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    uint8_t accCount = 0;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = Accessory::pFirstAccessory;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    {</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        accCount++;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    }</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="keywordflow">return</span> accCount;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;}</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<a class="code" href="classAccessory.html">Accessory</a> *Accessory::GetById(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;{</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = Accessory::pFirstAccessory;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    {</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(inId) != (uint8_t)-1)</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;            <span class="keywordflow">return</span> pCurr;</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    }</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <span class="keywordflow">return</span> NULL;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;}</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00260"></a><span class="lineno"><a class="line" href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">  260</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">Accessory::IsActionPending</a>()</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;{</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *pCurr = Accessory::pFirstAccessory;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <span class="keywordflow">while</span> (pCurr != NULL)</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    {</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        <span class="keywordflow">if</span> (pCurr-&gt;<a class="code" href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">IsActionDelayPending</a>())</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        pCurr = pCurr-&gt;<a class="code" href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">GetNextAccessory</a>();</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    }</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;}</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;<span class="keywordtype">bool</span> Accessory::CanMove(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;{</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *acc = GetById(inId);</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <span class="keywordflow">if</span> (acc == NULL)</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="comment">// Move if there is more than one MovingPosition (no toggle id), and moving ids are the same than</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <span class="comment">// previous time...</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordflow">if</span> (acc-&gt;<a class="code" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a>() &gt; 1)</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    {</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordtype">bool</span> move = acc-&gt;<a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(inId) != acc-&gt;<a class="code" href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">GetLastMovingPosition</a>();</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        <span class="keywordflow">if</span> (!move)</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            Serial.println(F(<span class="stringliteral">&quot;Same position : Cant move !&quot;</span>));</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        <span class="keywordflow">return</span> move;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    }</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keywordflow">if</span> (millis() - acc-&gt;<a class="code" href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">GetLastMoveTime</a>() &lt;= acc-&gt;<a class="code" href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">GetDebounceDelay</a>())</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    {</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        Serial.println(F(<span class="stringliteral">&quot;Debounce : Cant move !&quot;</span>));</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    }</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    acc-&gt;<a class="code" href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">SetLastMoveTime</a>();</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;}</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Accessory::Toggle</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;{</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a>)</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    {</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; ---- Stack id &quot;</span>));</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        Serial.println(inId);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        <a class="code" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a>.<a class="code" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a>(inId, ACCESSORIES_EVENT_MOVEPOSITIONID);</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    }</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *acc = GetById(inId);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keywordflow">if</span> (acc == NULL)</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    {</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    }</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    <span class="keywordflow">if</span> (!CanMove(inId))</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    {</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    }</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    uint8_t pos = acc-&gt;<a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(inId);</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="keywordflow">if</span> (pos == 255)</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    {</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    }</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;    acc-&gt;<a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a>(pos);</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;Toggle : Accessory id &quot;</span>));</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    Serial.println(inId);</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    acc-&gt;<a class="code" href="classAccessory.html#a2ab6995aadf87dd3f7edf1d2f448ab85">Move</a>(inId);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;}</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;<span class="keywordtype">bool</span> Accessory::MovePosition(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId)</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;{</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *acc = GetById(inId);</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keywordflow">if</span> (acc == NULL)</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    {</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    }</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    uint8_t pos = acc-&gt;<a class="code" href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">IndexOfMovingPosition</a>(inId);</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    <span class="keywordflow">if</span> (pos == 255)</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    {</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    }</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    <span class="keywordflow">if</span> (<a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a>)</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    {</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        Serial.print(F(<span class="stringliteral">&quot; ---- Stack id &quot;</span>));</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        Serial.println(inId);</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        <a class="code" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a>.<a class="code" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a>(inId, ACCESSORIES_EVENT_MOVEPOSITIONINDEX, pos);</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    }</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;    acc-&gt;<a class="code" href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">SetLastMovingPosition</a>(pos);</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    Serial.print(F(<span class="stringliteral">&quot;MovePosition : Accessory id &quot;</span>));</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;    Serial.print(inId);</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;    Serial.print(F(<span class="stringliteral">&quot; to position &quot;</span>));</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    Serial.println(acc-&gt;<a class="code" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">GetMovingPosition</a>(inId));</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    acc-&gt;MovePosition(acc-&gt;<a class="code" href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">GetMovingPosition</a>(inId));</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;</div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;}</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00388"></a><span class="lineno"><a class="line" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">  388</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, ACCESSORIES_EVENT_TYPE inEvent, <span class="keywordtype">int</span> inData)</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;{</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;    <span class="keywordflow">if</span> (!CanMove(inId) || (<a class="code" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a> &amp;&amp; inEvent != ACCESSORIES_EVENT_EXTERNALMOVE))</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;    {</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;        <a class="code" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a>.<a class="code" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a>(inId, inEvent, inData);</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;        <span class="keywordflow">return</span>;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    }</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    <a class="code" href="classAccessory.html">Accessory</a> *acc = GetById(inId);</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    <span class="keywordflow">if</span> (acc != NULL)</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;    {</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        <span class="keywordflow">if</span> (inEvent == ACCESSORIES_EVENT_MOVEPOSITIONINDEX &amp;&amp; (inData &lt; 0 || inData &gt;= acc-&gt;<a class="code" href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">GetMovingPositionSize</a>()))</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;        {</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="preprocessor">#ifdef ACCESSORIES_DEBUG_MODE</span></div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;            Serial.print(F(<span class="stringliteral">&quot;Accessory id &quot;</span>));</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;            Serial.print(inId);</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;            Serial.print(F(<span class="stringliteral">&quot; bad MovePositionIndex event &quot;</span>));</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;            Serial.println(inData);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;            <span class="keywordflow">return</span>;</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        }</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        acc-&gt;<a class="code" href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">Event</a>(inId, inEvent, inData);</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;    }</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;}</div><div class="ttc" id="classAccessory_html_a6f4a8cacc38e0bac6e83ed5a136073e0"><div class="ttname"><a href="classAccessory.html#a6f4a8cacc38e0bac6e83ed5a136073e0">Accessory::Event</a></div><div class="ttdeci">virtual void Event(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00266">Accessory.hpp:266</a></div></div>
<div class="ttc" id="classActionsStack_html_a12c3702836732893421ef6a75c504eda"><div class="ttname"><a href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">ActionsStack::Add</a></div><div class="ttdeci">unsigned char Add(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8cpp_source.html#l00031">ActionsStack.cpp:31</a></div></div>
<div class="ttc" id="classActionsStack_html_a458994617bfbd0f8aee0fb93abcdb347"><div class="ttname"><a href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">ActionsStack::Actions</a></div><div class="ttdeci">static ActionsStack Actions</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00069">ActionsStack.hpp:69</a></div></div>
<div class="ttc" id="classAccessory_html_a9f524a5ba6ba7f33e814e687c2912181"><div class="ttname"><a href="classAccessory.html#a9f524a5ba6ba7f33e814e687c2912181">Accessory::Toggle</a></div><div class="ttdeci">virtual ACC_STATE Toggle() = 0</div></div>
<div class="ttc" id="classAccessory_html_ae8c3ad3e37a2ba5914f419abd3e2426f"><div class="ttname"><a href="classAccessory.html#ae8c3ad3e37a2ba5914f419abd3e2426f">Accessory::IsActionDelayPending</a></div><div class="ttdeci">bool IsActionDelayPending() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00398">Accessory.hpp:398</a></div></div>
<div class="ttc" id="classAccessory_html_aa27a04b9e2a95729e491598cb34c6e47"><div class="ttname"><a href="classAccessory.html#aa27a04b9e2a95729e491598cb34c6e47">Accessory::GetNextAccessory</a></div><div class="ttdeci">Accessory * GetNextAccessory() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00360">Accessory.hpp:360</a></div></div>
<div class="ttc" id="classAccessory_html_a1d8deba14ebc355146c2ff26b4e4669c"><div class="ttname"><a href="classAccessory.html#a1d8deba14ebc355146c2ff26b4e4669c">Accessory::SetNextAccessory</a></div><div class="ttdeci">void SetNextAccessory(Accessory *inAccessory)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00350">Accessory.hpp:350</a></div></div>
<div class="ttc" id="classPort_html_a676359ed59bf5091126fd96e1a04cafa"><div class="ttname"><a href="classPort.html#a676359ed59bf5091126fd96e1a04cafa">Port::SetSpeed</a></div><div class="ttdeci">virtual int SetSpeed(int inSpeed)</div><div class="ttdef"><b>Definition:</b> <a href="Port_8cpp_source.html#l00108">Port.cpp:108</a></div></div>
<div class="ttc" id="classAccessory_html_a933cd0907dc257b1f1047c33d41ceb2a"><div class="ttname"><a href="classAccessory.html#a933cd0907dc257b1f1047c33d41ceb2a">Accessory::GetLastMoveTime</a></div><div class="ttdeci">unsigned long GetLastMoveTime() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00249">Accessory.hpp:249</a></div></div>
<div class="ttc" id="classAccessory_html_a245ad3bad4fa0f1d657fdc20b2edb868"><div class="ttname"><a href="classAccessory.html#a245ad3bad4fa0f1d657fdc20b2edb868">Accessory::EEPROMLoad</a></div><div class="ttdeci">virtual int EEPROMLoad(int inPos)</div></div>
<div class="ttc" id="classAccessory_html_ac4dc998e8f09ac7f94a3e06c56e8d5d4"><div class="ttname"><a href="classAccessory.html#ac4dc998e8f09ac7f94a3e06c56e8d5d4">Accessory::GetMovingPositionSize</a></div><div class="ttdeci">const uint8_t GetMovingPositionSize() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00323">Accessory.hpp:323</a></div></div>
<div class="ttc" id="classPort_html_aed93eb0b1e3fcb88843f6c5606d55621"><div class="ttname"><a href="classPort.html#aed93eb0b1e3fcb88843f6c5606d55621">Port::GetSpeed</a></div><div class="ttdeci">int GetSpeed() const </div><div class="ttdef"><b>Definition:</b> <a href="Port_8hpp_source.html#l00119">Port.hpp:119</a></div></div>
<div class="ttc" id="classAccessory_html_a292f4e066803d0f6f32a953216443c9d"><div class="ttname"><a href="classAccessory.html#a292f4e066803d0f6f32a953216443c9d">Accessory::GetLastMovingPosition</a></div><div class="ttdeci">const uint8_t GetLastMovingPosition() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00318">Accessory.hpp:318</a></div></div>
<div class="ttc" id="classActionsStack_html_aef1d9742f23cad44c4e85e0cfdf942e9"><div class="ttname"><a href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">ActionsStack::FillingStack</a></div><div class="ttdeci">static bool FillingStack</div><div class="ttdef"><b>Definition:</b> <a href="ActionsStack_8hpp_source.html#l00071">ActionsStack.hpp:71</a></div></div>
<div class="ttc" id="classAccessory_html_a49f289549f486e8307ec06123939ca40"><div class="ttname"><a href="classAccessory.html#a49f289549f486e8307ec06123939ca40">Accessory::EEPROMSave</a></div><div class="ttdeci">virtual int EEPROMSave(int inPos, bool inSimulate = false)</div></div>
<div class="ttc" id="classAccessory_html_a2ab6995aadf87dd3f7edf1d2f448ab85"><div class="ttname"><a href="classAccessory.html#a2ab6995aadf87dd3f7edf1d2f448ab85">Accessory::Move</a></div><div class="ttdeci">virtual void Move(unsigned long inMovingPositionId) = 0</div></div>
<div class="ttc" id="classAccessory_html_ae4efeb5b525027d5ccb692f0560a3474"><div class="ttname"><a href="classAccessory.html#ae4efeb5b525027d5ccb692f0560a3474">Accessory::IsActionPending</a></div><div class="ttdeci">static bool IsActionPending()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00260">Accessory.cpp:260</a></div></div>
<div class="ttc" id="classAccessory_html_a60e5e9122c96773c975fe9d2c2db6520"><div class="ttname"><a href="classAccessory.html#a60e5e9122c96773c975fe9d2c2db6520">Accessory::SetStateRaw</a></div><div class="ttdeci">void SetStateRaw(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00165">Accessory.cpp:165</a></div></div>
<div class="ttc" id="classAccessory_html_af693b11f2a3b1a7c93d7fa43e600f292"><div class="ttname"><a href="classAccessory.html#af693b11f2a3b1a7c93d7fa43e600f292">Accessory::ActionEnded</a></div><div class="ttdeci">virtual bool ActionEnded()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00134">Accessory.cpp:134</a></div></div>
<div class="ttc" id="classAccessory_html_af8b0920b2a419e278fbc79e3fcc75f86"><div class="ttname"><a href="classAccessory.html#af8b0920b2a419e278fbc79e3fcc75f86">Accessory::GetCount</a></div><div class="ttdeci">static uint8_t GetCount()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00233">Accessory.cpp:233</a></div></div>
<div class="ttc" id="classAccessory_html_a3de65543a892b3418df72f54439605cb"><div class="ttname"><a href="classAccessory.html#a3de65543a892b3418df72f54439605cb">Accessory::ResetAction</a></div><div class="ttdeci">virtual void ResetAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00385">Accessory.hpp:385</a></div></div>
<div class="ttc" id="classAccessory_html_a5e837b6c4251c2fe69066d3146dd8478"><div class="ttname"><a href="classAccessory.html#a5e837b6c4251c2fe69066d3146dd8478">Accessory::SetLastMovingPosition</a></div><div class="ttdeci">void SetLastMovingPosition(uint8_t inLastPositionIndex)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00157">Accessory.cpp:157</a></div></div>
<div class="ttc" id="classAccessory_html_ab1dad31ee3bcac4b1baf9a140c7fa57d"><div class="ttname"><a href="classAccessory.html#ab1dad31ee3bcac4b1baf9a140c7fa57d">Accessory::StartAction</a></div><div class="ttdeci">virtual void StartAction()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00077">Accessory.cpp:77</a></div></div>
<div class="ttc" id="classAccessory_html_a224977dffaa54df56def6a7b15af0031"><div class="ttname"><a href="classAccessory.html#a224977dffaa54df56def6a7b15af0031">Accessory::IndexOfMovingPosition</a></div><div class="ttdeci">uint8_t IndexOfMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00059">Accessory.cpp:59</a></div></div>
<div class="ttc" id="classAccessory_html_a408602468720dbf84c1e3d27cc0385da"><div class="ttname"><a href="classAccessory.html#a408602468720dbf84c1e3d27cc0385da">Accessory::SetState</a></div><div class="ttdeci">virtual void SetState(ACC_STATE inNewState)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00430">Accessory.hpp:430</a></div></div>
<div class="ttc" id="structMovingPosition_html_a0136a4ea90e9f0e61eebc441ed359e44"><div class="ttname"><a href="structMovingPosition.html#a0136a4ea90e9f0e61eebc441ed359e44">MovingPosition::Position</a></div><div class="ttdeci">int Position</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00077">Accessory.hpp:77</a></div></div>
<div class="ttc" id="structMovingPosition_html_a2b52fcb92f3b4147f03fafe3c292029c"><div class="ttname"><a href="structMovingPosition.html#a2b52fcb92f3b4147f03fafe3c292029c">MovingPosition::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00076">Accessory.hpp:76</a></div></div>
<div class="ttc" id="structMovingPosition_html"><div class="ttname"><a href="structMovingPosition.html">MovingPosition</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00074">Accessory.hpp:74</a></div></div>
<div class="ttc" id="classAccessory_html_acd67b5953eb1b55a52a87a779574e3b6"><div class="ttname"><a href="classAccessory.html#acd67b5953eb1b55a52a87a779574e3b6">Accessory::AdjustMovingPositionsSize</a></div><div class="ttdeci">void AdjustMovingPositionsSize(uint8_t inNewSize)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00029">Accessory.cpp:29</a></div></div>
<div class="ttc" id="classAccessory_html_a6cf36c65d1519eb7e5a6aac1cba7fe51"><div class="ttname"><a href="classAccessory.html#a6cf36c65d1519eb7e5a6aac1cba7fe51">Accessory::ExecuteEvent</a></div><div class="ttdeci">static void ExecuteEvent(unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent = ACCESSORIES_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00388">Accessory.cpp:388</a></div></div>
<div class="ttc" id="classAccessory_html_af4a38203fce08f72755835ff126bddb0"><div class="ttname"><a href="classAccessory.html#af4a38203fce08f72755835ff126bddb0">Accessory::SetLastMoveTime</a></div><div class="ttdeci">void SetLastMoveTime()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00339">Accessory.hpp:339</a></div></div>
<div class="ttc" id="classAccessory_html_ae1ebffdf3fe753e3c5e7d05c2a61fd18"><div class="ttname"><a href="classAccessory.html#ae1ebffdf3fe753e3c5e7d05c2a61fd18">Accessory::pPort</a></div><div class="ttdeci">Port * pPort</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00167">Accessory.hpp:167</a></div></div>
<div class="ttc" id="classAccessory_html_ac2883977d969dcde8f078934b4a9ed12"><div class="ttname"><a href="classAccessory.html#ac2883977d969dcde8f078934b4a9ed12">Accessory::GetPort</a></div><div class="ttdeci">Port * GetPort() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00185">Accessory.hpp:185</a></div></div>
<div class="ttc" id="classAccessory_html_aa249535a3c36291764e38ab1e4ae4cee"><div class="ttname"><a href="classAccessory.html#aa249535a3c36291764e38ab1e4ae4cee">Accessory::GetMovingPosition</a></div><div class="ttdeci">int GetMovingPosition(unsigned long inId) const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00068">Accessory.cpp:68</a></div></div>
<div class="ttc" id="classAccessory_html_a57d1cb4de69eb625fc2bb82788591a22"><div class="ttname"><a href="classAccessory.html#a57d1cb4de69eb625fc2bb82788591a22">Accessory::AddMovingPosition</a></div><div class="ttdeci">uint8_t AddMovingPosition(unsigned long inId, int inPosition)</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00049">Accessory.cpp:49</a></div></div>
<div class="ttc" id="classAccessory_html_a64e6260a68ac84d94394a2076746f98a"><div class="ttname"><a href="classAccessory.html#a64e6260a68ac84d94394a2076746f98a">Accessory::Accessory</a></div><div class="ttdeci">Accessory()</div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8cpp_source.html#l00015">Accessory.cpp:15</a></div></div>
<div class="ttc" id="classAccessory_html_ac818b7112183d3d65ec361c8402f927f"><div class="ttname"><a href="classAccessory.html#ac818b7112183d3d65ec361c8402f927f">Accessory::GetDebounceDelay</a></div><div class="ttdeci">unsigned int GetDebounceDelay() const </div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00243">Accessory.hpp:243</a></div></div>
<div class="ttc" id="classAccessory_html"><div class="ttname"><a href="classAccessory.html">Accessory</a></div><div class="ttdef"><b>Definition:</b> <a href="Accessory_8hpp_source.html#l00140">Accessory.hpp:140</a></div></div>
<div class="ttc" id="Accessories_8h_html"><div class="ttname"><a href="Accessories_8h.html">Accessories.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>Accessory.cpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
